<?php
	
//------------------------------------------------------------------------
// This script is a part of ABC Mail Manager
//
// Version: 2.5
// Homepage: www.zakkis.ca
// Copyright (c) 2002-2003 Zakkis Technology, Inc.
// All rights reserved.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
// "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
// LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
// FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
// REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
// INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
// SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
// HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
// STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
// ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
// OF THE POSSIBILITY OF SUCH DAMAGE.
//
//------------------------------------------------------------------------
	

class MenuItemContent {
	var $title;
	var $processor;

	function MenuItemContent( $title, $processor )
	{
		$this->title = $title;
		$this->processor = $processor;
	}		

} // end of MenuItemContent

class MenuItem {

	var $name;
	var $target;
	var $content_id;
	var $content;
	
	function MenuItem( $name, $title, $processor )
	{
		$this->name = $name;
		$this->AddContent( $title, $processor );
	}
	
	function PrintTitle()
	{
		$title = $this->GetTitle();
		print <<<END
			<p><br>
			<p align="left"><font class="chapterName1">
			$title
			</font></p>
END;
	}
	
	function GetTitle()
	{
		$this->SetupContent();
		return $this->content[ $this->content_id ]->title;
	}
	
	function PrintContent()
	{
		$target=$this->target;
		$ctx = $this->content_id;
		print "\n";
		
		$processor = $this->content[ $this->content_id ]->processor;
		include $processor;
	}
	
	function AddContent( $title, $processor )
	{
		$this->content[] = new MenuItemContent( $title, $processor );
	}
	
	function SetupContent()
	{
		global $ctx;
		
		if( isset( $ctx ) && 0 <= $ctx && $ctx < count( $this->content ) )
			$this->content_id = $ctx;
		else
			$this->content_id = 0;
	}
	
} // end of MenuItem


class Menu {

	var $items;
	var $selected;
	var $script;
	var $title;

	function Menu( $script, $items ) {
		global $mid;
		
		$this->script = $script;
		$this->items = $items;
		
		for( $i = 0; $i < count( $this->items ); $i++ )
			if( !isset( $this->items[ $i ]->target ) )
				$this->items[ $i ]->target = $script . "?mid=$i";
					
		// Find selected menu item
		if( isset( $mid ) )
			$this->selected = $mid;
		else
			$this->selected = 0;
			
		// Validate selected menu item
		if( $this->selected < 0 )
			$this->selected = 0;
		if( $this->selected >= count( $this->items ) )
			$this->selected = count( $this->items ) - 1;
			
		$this->title = $items[ $this->selected ]->GetTitle();
	}
	
	function GetCount()
	{
		return count( $this->items );
	}
	
	function PrintMenuPart( $start, $end )
	{
		for( $index = $start; $index < $end; $index++ )
		{
			$item = $this->items[ $index ];
			
			if( $this->selected == $index )
				$this->PrintSelected( $item );
			else
				$this->PrintItem( $item, $index );
		}
	}
	
	function PrintSeparator( $name = "" )
	{
		print <<<END
	<tr><td><img src="images/spacer.gif" width="1" height="10" border="0"></td></tr>		
	<tr><td><font class="menu_name">$name</font></td></tr>
	<tr><td bgcolor="#CC9900"><img src="images/spacer.gif" width="1" height="1" border="0"></td></tr>
	<tr><td><img src="images/spacer.gif" width="1" height="10" border="0"></td></tr>
END;
	}
	
	function PrintMenu()
	{
		$index = 0;
		foreach( $this->items as $item )
		{
			if( $this->selected == $index )
				$this->PrintSelected( $item );
			else
				$this->PrintItem( $item, $index );
				
			$index++;
		}
	}
	
	function PrintSelected( $item )
	{
		print "\t<tr><td><img src=images/spacer.gif width=1 height=10></td></tr>\n";
		print "\t<tr><td><img src=images/spacer.gif width=10><font class=menu_item>$item->name</font></td></tr>\n";
		print "\t<tr><td><img src=images/spacer.gif width=1 height=10></td></tr>\n";
	}

	function PrintItem( $item, $index )
	{
	print <<<END
	<tr><td><img src="images/spacer.gif" width="1" height="10" border="0"></td></tr>
	<tr><td><img src="images/spacer.gif" width="10"><a class=menu_link method="post" href="$item->target">$item->name</a></td></tr>
	<tr><td><img src="images/spacer.gif" width="1" height="10" border="0"></td></tr>
END;
	}
	
	function PrintContent()
	{
		$item = $this->items[ $this->selected ];
		
		$item->SetupContent();
		$item->PrintTitle();
		$item->PrintContent();
	}
	
} // end of class Menu

?>