<?
	
//------------------------------------------------------------------------
// This script is a part of ABC Mail Manager
//
// Version: 2.5
// Homepage: www.zakkis.ca
// Copyright (c) 2002-2003 Zakkis Technology, Inc.
// All rights reserved.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
// "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
// LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
// FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
// REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
// INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
// SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
// HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
// STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
// ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
// OF THE POSSIBILITY OF SUCH DAMAGE.
//
//------------------------------------------------------------------------
	
	include_once ('class/MailList.class.inc');
	
	CheckCallIsCorrect();
	
	global $HTTP_POST_VARS, $HTTP_GET_VARS, $REQUEST_METHOD, $folders, $active_folder;
	
	if( !isset( $active_folder ) )
	{
		echo "<font class=bodyText>You should define though one maillist first.<br>
		Please, go to the menu <a href=\"MailManager.php?mid=0\">Folders/Manage</a> and add the maillist.
		</font>";
		exit;		
	}
	
	$sort = array( '*'=>'name', 'name' => '*', 'address' => ' ');
	$sort_field = 'name';
	
	if( isset( $HTTP_GET_VARS['sort'] ) )
	{
		$sort_field = $HTTP_GET_VARS['sort'];
		if( $sort[ $sort_field ] != '*' )
		{
			$curfield = $sort['*'];
			$sort[ $curfield ] = ' ';
			$sort[ $sort_field ] = '*';
			$sort['*'] = $sort_field;
		}
	}
	
	if( $REQUEST_METHOD == 'POST' && !IsDemo() )
	{
		// Apply sort
		
		$sort_field = $HTTP_POST_VARS['sort'];
		if( $sort[ $sort_field ] != '*' )
		{
			$curfield = $sort['*'];
			$sort[ $curfield ] = ' ';
			$sort[ $sort_field ] = '*';
			$sort['*'] = $sort_field;
		}
	
		// Iterate all mails in list

		$mail_list = new MailList;
		$mail_list->Sort( $sort['*'] );
		$keys = array_keys( $mail_list->mails );
		
		for( $i = 0; $i < count( $keys ); $i++ )
		{
			$key = $keys[ $i ];
			if( !isset($HTTP_POST_VARS[ "id$key" ]) )
				continue;
				
			$index = $HTTP_POST_VARS[ "id$key" ];

			if( isset( $HTTP_POST_VARS[ "dis$index" ] ) )
				$mail_list->mails[ $key ]->mail_disabled = true;
			else
				$mail_list->mails[ $key ]->mail_disabled = false;
			
			if( isset( $HTTP_POST_VARS[ "del$index" ] ) )
				unset( $mail_list->mails[ $key ] );				
		}
		
		$mail_list->Write();
	}
	
	if( $REQUEST_METHOD == 'POST' && IsDemo() )
	{
		print "<P align=center class=varningText>You can not edit addresses as guest.</P>";
	}
	
	// create folder active mail list
	
	$mail_list = new MailList( 1 );
	$mail_list->Sort( $sort['*'] );
	$mail_count = count($mail_list->mails);
	
	// calculate navigator parameters
	
	include_once ('data/options.inc');
	$pg_entries = $MailsOnPage;
	if( !is_numeric( $pg_entries ) || ((integer) $pg_entries) <= 0 )
		$pg_entries = 25;
	
	$pg_no = 1;
	if( isset( $HTTP_POST_VARS['pg'] ) )
		$pg_no = $HTTP_POST_VARS['pg'];
	if( isset( $HTTP_GET_VARS['pg'] ) )
		$pg_no = $HTTP_GET_VARS['pg'];
	$pg_count = floor( $mail_count / $pg_entries );
	if( $mail_count % $pg_entries > 0 )
		$pg_count ++;
	if( $pg_no > $pg_count )
		$pg_no = $pg_count;
	$entry_start = ( $pg_no - 1 ) * $pg_entries;
	$entry_end = $entry_start + $pg_entries - 1;
	
	// method to print header & footer
	
	function PrintCountNavigator( $target, $sort_field, $pg_count, $pg_no, $mail_count )
	{	
		$parsed_target = parse_url( $target );
		if( $parsed_target[query] != '' )
			$parsed_target[query] .= "&sort=$sort_field&";
		else
			$parsed_target[query] = "sort=$sort_field&";
		$parsed_target[query] .= 'pg';
		$pg_target = $parsed_target[path] . '?' . $parsed_target[query];

		echo "Count: " . $mail_count . "&nbsp;&nbsp;&nbsp;";
		if( $pg_count > 1 )
		{
			if( $pg_no != 1 )
			{
				$pg_prev = $pg_no - 1;
				echo "<a href=\"$pg_target=$pg_prev\">&lt;&lt;</a>";
			}
			else
				echo "<b>&lt;&lt;</b>";
			
			for( $i = 1; $i <= $pg_count; $i++ )
			{
				echo '&nbsp;&nbsp;';
				if( $pg_no != $i )
					echo "<a href=\"$pg_target=$i\">$i</a>";
				else
					echo "<b>$i</b>";
			}
			
			echo '&nbsp;&nbsp;';
			if( $pg_no != $pg_count )
			{
				$pg_next = $pg_no + 1;
				echo "<a href=\"$pg_target=$pg_next\">&gt;&gt;</a>";
			}
			else
				echo "<b>&gt;&gt;</b>";
		}
	}
?>

<script language="JavaScript">
<!--
function SelectAll_Del()
{
	var i = 1;
	var chk = document.edit_form.selall_del.checked;
	while( eval('document.edit_form.del'+i) )
	{
 		eval('document.edit_form.del'+i+'.checked = chk');
		i++;
	}
}
function SelectAll_Dis()
{
	var i = 1;
	var chk = document.edit_form.selall_dis.checked;
	while( eval('document.edit_form.dis'+i) )
	{
 		eval('document.edit_form.dis'+i+'.checked = chk');
		i++;
	}
}
function ApplySort(field)
{
	document.edit_form.sort.value = field;
}

// -->
</script>

<form name="edit_form" method="post" action="<?=$target;?>">
<input type=hidden name=sort value="<?=$sort['*'];?>">
<table width="90%" class="bodyText">
<tr>
	<td colspan="5" class=BlackText>
	<?
		if( $mail_count > 0 )
			PrintCountNavigator( $target, $sort_field, $pg_count, $pg_no, $mail_count );
		else
			echo "&nbsp;";
	?>
	</td>
</tr>
<tr>
	<td width="7%" bgcolor="#e0e0e0">&nbsp;
	</td>
	<td width="20%" bgcolor="#e0e0e0" valign="top">
		<input type="submit" value="<?=$sort[name];?>" onclick="ApplySort('name');"
			style="{height: 18px}"> Name
	</td>
	<td width="45%" bgcolor="#e0e0e0"  valign="top">
		<input type="submit" value="<?=$sort[address];?>" onclick="ApplySort('address');"
			style="{height: 18px}"> Address
	</td>
	<td bgcolor="#e0e0e0"  valign="top">
		Edit
	</td>
	<td bgcolor="#e0e0e0"  valign="top">
		Delete
	</td>
	<td bgcolor="#e0e0e0"  valign="top">
		Disabled
	</td>
</tr>

<?php
	$index = 1;
	$entry_index = 0;
	
	foreach( $mail_list->mails as $key => $mail )
	{
		if( $entry_index < $entry_start || $entry_end < $entry_index )
		{
			$entry_index++;
			continue;
		}
		$entry_index++;
	
		$txt_class = "BlackText";
		$check = "";
		if( $mail->mail_disabled )
		{
			$check = "checked";
			$txt_class = "DisabledAddress";
		}
		
		$desc_ = $mail->desc;
		$email_ = htmlentities( $mail->email );
		$data = crc32($email_);

		print <<<END
		<tr>
			<td>
				<input type="hidden" name="id$key" value="$index">
				<img src="images/mail.gif">&nbsp;<b>$entry_index</b>
			</td>
			<td class=$txt_class>
				$desc_
			</td>
			<td class=$txt_class>
				$email_
			</td>
			<td>
				<a href="MailManager.php?mid=2&ctx=1&data=$data">edit</a>
			</td>
			<td>
				<input name="del$index" type=checkbox>
			</td>
			<td>
				<input name="dis$index" type=checkbox $check>
			</td>
		</tr>
END;
		$index++;
	}
?>

<?php if( $mail_count != 0 ) : ?>

<tr><td colspan="6" height="10" bgcolor="#e0e0e0"></td></tr>
<tr>
	<td colspan="4">&nbsp;</td>
	<td>
		<input name="selall_del" type=checkbox value="Select All" onclick="javascript:SelectAll_Del();">
		<font color="red" size=-1>Select All</font>
	</td>
	<td>
		<input name="selall_dis" type=checkbox value="Select All" onclick="javascript:SelectAll_Dis();">
		<font color="red" size=-1>Select All</font>
	</td>
</tr>
<tr><td colspan="6" height="10" bgcolor="#e0e0e0"></td></tr>

<tr>
	<td colspan="5" class=BlackText>
<?
	PrintCountNavigator( $target, $sort_field, $pg_count, $pg_no, $mail_count );
?>
	</td>
	<td>
		<input type=hidden name="pg" value="<?=$pg_no;?>">
		<input name="submit" type=submit value="Update">
	</td>
</tr>

<? else: ?>
	<td colspan="5" align=center class=bodyText>No users in database.</td>
<? endif; ?>

</table>

</form>