<?php
	
//------------------------------------------------------------------------
// This script is a part of ABC Mail Manager
//
// Version: 2.5
// Homepage: www.zakkis.ca
// Copyright (c) 2002-2003 Zakkis Technology, Inc.
// All rights reserved.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
// "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
// LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
// FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
// REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
// INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
// SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
// HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
// STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
// ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
// OF THE POSSIBILITY OF SUCH DAMAGE.
//
//------------------------------------------------------------------------
	
	set_time_limit(0);
	global $Correct;
	if( !isset( $Correct ) )
	{
		header("Location: index.php");
		exit();
	}

	global $HTTP_POST_VARS, $HTTP_POST_FILES,
		   $HTTP_ACCEPT_ENCODING, $HTTP_ACCEPT_CHARSET,
		   $folders, $active_folder;
	
	if( !isset( $active_folder ) )
	{
		echo "<font class=bodyText>You should define though one maillist first.<br>
		Please, go to the menu <a href=\"MailManager.php?mid=0\">Folders/Manage</a> and add the maillist.
		</font>";
		exit;		
	}
	
	function PrintStandardForm( $print_back = false )
	{
		global $HTTP_POST_VARS;
		
		$back_button = '';
		if( $print_back )
		{
			$back_button = "<input type=button value=Back onclick=\"javascript:GotoContext('1');\">
					&nbsp;&nbsp;&nbsp;";
					
			// Output session state
			foreach ($HTTP_POST_VARS as $var => $value)
			{
				if( strstr( $var, 'Attachment' ) == $var ||
					strstr( $var, 'mailto' ) == $var ||
					($var == 'CustomTo' && $value != "") ||
					$var == 'FromName0' ||
					$var == 'FromAddr0' ||
					$var == 'ReplyToName0' ||
					$var == 'ReplyToAddr0' ||
					$var == 'Charset0' ||
					$var == 'MessageFormat0' ||
					$var == 'Subject0' ||
					$var == 'IncludeHeader' ||
					$var == 'IncludeFooter' ||
					$var == 'MessageText' ||
					$var == 'SendStyle' )
				{
				if( $var == 'Subject0' ||
					$var == 'MessageText' )
					$value0 = base64_encode( $value );
				else
					$value0 = $value;
					$back_button .= "\n\t<input type=hidden name=\"$var\" value=\"$value0\">";
				}
			}
		}
	
	print <<<END
	<script language="JavaScript" src="send.js">
	</script>
	
	<form name="edit_form" method="post" action="$target">
		<input type=hidden name="ctx" value="0">
		$back_button
		<input type=submit name="Next" value="Send another E-Mail">
	</table>
	</form>
END;
	}

	
	include_once ('class/MailList.class.inc');
	include_once ('class/UploadForm.class.inc');
	include_once ('class/phpmailer.class.inc');
	include_once ('class/utils.php');
	include ('data/options.inc');
	include_once ('strip_html.php');
	
	$upload = new UploadForm('upload');
	$list = new MailList ( 1 );
	$mailer = new phpmailer;
	
	// Set content type
	$IsHTML = $HTTP_POST_VARS['MessageFormat0'] == "1" ? true : false;
	$mailer->IsHTML( $IsHTML );
	
	// Set charset
	if( isset($HTTP_POST_VARS['Charset0']) )
		$mailer->CharSet = $HTTP_POST_VARS['Charset0'];
		
	// Get send style
	$SendStyle = 0;
	if( isset( $HTTP_POST_VARS['SendStyle'] ) )
	{
		$SendStyle = (integer) $HTTP_POST_VARS['SendStyle'];
		if( $SendStyle < 0 || $SendStyle > 2 )
			$SendStyle = 0;
	}
	
	// Setup mailer type
	switch( $MailMethod )
	{
	case 1:
		$mailer->IsSendmail();
		break;
	case 2:
		$mailer->IsQmail();
		break;
	case 3:
		$mailer->IsSMTP();
		break;

	case 0:
	default:
		$mailer->IsMail();
		break;
	}
	
	// Set From
	$mailer->From = trim($HTTP_POST_VARS['FromAddr0']);
	$mailer->FromName = trim($HTTP_POST_VARS['FromName0']);
	if( $mailer->FromName == '' )
		$mailer->FromName = $mailer->From;
	
	// Set Reply-To
	if( isset( $HTTP_POST_VARS['ReplyToAddr0'] ) )
	{
		$ReplyToAddr = trim($HTTP_POST_VARS['ReplyToAddr0']);
		$ReplyToName = trim($HTTP_POST_VARS['ReplyToName0']);
		if( $ReplyToAddr != '' )
		{
			if( $ReplyToName == '' )
				$ReplyToName = $ReplyToAddr;
			$mailer->AddReplyTo( $ReplyToAddr, $ReplyToName );
		}
	}
		
	// Set subject
	$mailer->Subject = stripslashes( base64_decode( $HTTP_POST_VARS['Subject0'] ) );
	
	// Attachemnt paths for archiving
	$paths = array();
	
	// Attach files
	foreach( $upload->data as $attachment )
	{
		$name = $attachment['name'];
		if( $name == "" )
			continue;
			
		if( !$mailer->AddAttachment( $attachment['file'], $name ) )
		{
			print <<<END
Failed to attach file $name. Use Back button to correct the error.
END;
			PrintStandardForm( true );
			exit();
		}
		
		$cur = count( $paths );
		$paths[ $cur ][ 0 ] = $name;
		$paths[ $cur ][ 1 ] = $attachment['file'];
	}
	
	// Construct the body
	if( isset( $HTTP_POST_VARS['IncludeHeader'] ) )
	{
		$Body = $HeaderText;
		$Body .= "\n";
	}
	
	$Body .= base64_decode( $HTTP_POST_VARS['MessageText'] );
	
	if( isset( $HTTP_POST_VARS['IncludeFooter'] ) )
	{
		$Body .= "\n";
		$Body .= $FooterText;
	}
	
	$Body = stripslashes( $Body );

	$mailer->Body = $Body;
	if( $IsHTML )
		$mailer->AltBody = StripHTMLTags( $Body );
	
	// Configure Smtp options
	$mailer->Host = $SmtpHost;
	$mailer->Port = $SmtpPort;
	$mailer->Helo = $SmtpHelo;
	$mailer->Username = $SmtpUsername;
	$mailer->Password = $SmtpPassword;
	
	// Collect recipients addresses
	$addrs = array();
	foreach ($HTTP_POST_VARS as $var => $value)
	{
		$key = substr( $value, 3 );
		settype($key, "integer");
		$mail = $list->mails[ $key ];
		
		if( strstr( $var, 'mailto' ) == $var )
		{
			$cur = count( $addrs );
			$addrs[ $cur ][0] = $mail->email;
			$addrs[ $cur ][1] = $mail->desc;
		}
		
		if( $var == 'CustomTo' && $value != "" )
		{
			$mails = split( '[,;]', $value );
			foreach( $mails as $addr )
			{
				$cur = count( $addrs );
				$addrs[ $cur ][0] = $addr;
			}
		}
	}
	
	if( count( $addrs ) == 0 )
	{
		print 'You must provide at least one recipient email address.<br>';
		PrintStandardForm( true );
		exit();
	}
	
	// Sending
	switch( $SendStyle )
	{
	case 0:	// Standard send
		foreach( $addrs as $addr )
		{
			$mailer->AddAddress( $addr[0], $addr[1] );
			if( IsDemo() )
				break;
		}
		if( !$mailer->Send() )
		{
			print $mailer->ErrorInfo;
			PrintStandardForm( true );
			exit();
		}
		break;
	
	case 1:	// Use BCC field
		foreach( $addrs as $addr )
		{
			$mailer->AddBCC( $addr[0], $addr[1] );
			if( IsDemo() )
				break;
		}
		if( !$mailer->Send() )
		{
			print $mailer->ErrorInfo;
			PrintStandardForm( true );
			exit();
		}
		break;
	
	case 2: // Separate letter for each
		foreach( $addrs as $addr )
		{
			$mailer->Body = str_replace( 
				array(	'<%NAME%>',
						'<%EMAIL%>',
						'<%FOLDER%>',
						'<%UNSUBSCRIBE%>'),
				array( $addr[1],
					   $addr[0],
					   $active_folder,
					   GetUnsubscribeURL( $addr[1], $addr[0], $active_folder ) ),
				$Body );
			if( $IsHTML )
				$mailer->AltBody = StripHTMLTags( $mailer->Body );
				
			$mailer->AddAddress( $addr[0], $addr[1] );
			if( !$mailer->Send() )
				print "<font color=\"#dd0000\">Failed to send to $addr[0]. $mailer->ErrorInfo.</font><br>";
			else
				print "<font color=\"#0000dd\">Mail send to $addr[0].</font><br>";
			$mailer->ClearAddresses();
			
			if( IsDemo() )
				break;
		}
		break;
	}
	
	// Output success message
	print '<p align=left class="bodyText">Mail has been successfully sent.</p>';
	if( IsDemo() )
	{
		print '<p align=left class="varningText">Demo version restrictions: Letter has been send only to the first recipient. Others are ignored.<br>';
		print 'In demo version letters were not saved into archive.</p>';
	}
	
	// Writing message to the archive
	include_once ('class/ArchiveIndex.class.inc');
	
	$archive = new ArchiveIndex ( true, $active_folder );
	$archive->AddLetter( $IsHTML ? "htm" : "txt" , $mailer->Subject, $Body, $paths, $active_folder );
	if( !IsDemo() )
		$archive->Write();
	
	// Output page form
	PrintStandardForm();
?>
